<script>
	export let id="slider_component";
	export let titleText="";
	export let min=0;
	export let max=1;
	export let step=0.01;
	export let colorvalue;
	export let opacityvalue;
	export let fill='fillfromleft';
	export let oninput = function() {};
</script>

<div class="colorslider" style="--colorvalue: {colorvalue}; --opacityvalue: {0.2+opacityvalue*0.8}">
<label for={id}>{titleText}</label>
<input id={id} type='color' bind:value={colorvalue}/>
<input id={id} class={fill} type='range' min={min} max={max} step={step} bind:value={opacityvalue} on:input={oninput}/>
</div>

<style>
	div.colorslider{
		padding: 2px;
	}

	label{
		display: inline;
		font-size: 10pt;
		margin: 2px;
		padding: 0px;
	}

	input[type="color"]{
		width: 40px;
		height: 20px;
		text-align: right;
		vertical-align: top;
		padding: 0px;
		margin: 0px;
		border-width: 1px;
		border-radius: 5px;
		background-color: "#f00";
	}

	input[type="color"]::-webkit-color-swatch-wrapper {
		padding: 0;
		border: 1;
		border-radius: 5px;
	}

	input[type="color"]::-webkit-color-swatch {
		border: 0px;
		margin: 3px;
		border-radius: 3px;
	}

	/* Hide the up-down arrows on the number field */
	input::-webkit-outer-spin-button,
	input::-webkit-inner-spin-button {
	  -webkit-appearance: none;
	  margin: 0;
	}

	input[type="range"]{
		vertical-align: middle;
		margin: 0px;
		padding: 0px;
		outline: 0;
		border: 0;
		border-radius: 5px;
		width: 150px;
		max-width: 100%;
		margin: 0px;
		transition: box-shadow 0.2s ease-in-out;
		overflow: hidden;
		height: 20px;
		-webkit-appearance: none;
		background-color: #ddd;
	}

	input[type="range"]::-webkit-slider-runnable-track {
		height: 20px;
		-webkit-appearance: none;
		color: #444;
		cursor: pointer;
	}

	input[type="range"]::-webkit-slider-thumb {
		width: 20px;
		-webkit-appearance: none;
		height: 20px;
		cursor: ew-resize;
		background: #fff;
		border-radius: 5px;
		position: relative;
	}

	input[type="range"].fillfromright::-webkit-slider-thumb {
		box-shadow: 340px 0 0 330px var(--colorvalue), inset 0 0 0 3px var(--colorvalue);
	}

	input[type="range"].fillfromleft::-webkit-slider-thumb {
		box-shadow: -340px 0 0 330px var(--colorvalue), inset 0 0 0 3px var(--colorvalue);
		opacity: var(--opacityvalue);
	}



</style>
